****************************************************************************
****************************************************************************
**                                                                        **
**   Phoenix for Fargo II : Enemy Bullet Routines                         **
**                                                                        **
**   Copyright 1997-2000 by Patrick Davidson.  All Rights Reserved.       **
**                                                                        **
**   This file was last updated April 15, 2000                            **
**                                                                        **
**   For complete copyright information and contact addresses, refer to   **
**   the main source file "PHOENIX.ASM"                                   **
**                                                                        **
****************************************************************************
****************************************************************************

******************************************** HANDLE ENEMY BULLETS

Enemy_Bullets:
         lea      enemy_bullets(a5),a4       ; A4 -> Enemy bullet entry
         moveq    #15,d7
loop_draw_enemy_bullets:
         move.w   (a4),d6                    ; Test for bullet's presence
         beq.s    ebd_no_bullet_here

         move.w   eb_x(a4),d0                ; Draw the bullet
         move.w   eb_y(a4),d1
         move.w   eb_image(a4),d2
         bsr      Xor_Sprite_D2

         move.w   player_yc(a5),d0           ; Test for collision w/ player
         add.w    player_height(a5),d0
         sub.w    eb_y(a4),d0
         blt.s    ebd_no_collision
         sub.w    player_height(a5),d0
         sub.w    eb_h(a4),d0
         bgt.s    ebd_no_collision
         
         move.w   player_xc(a5),d0
         add.w    player_width(a5),d0
         sub.w    eb_x(a4),d0
         blt.s    ebd_no_collision
         sub.w    player_width(a5),d0
         sub.w    eb_w(a4),d0
         bgt.s    ebd_no_collision

         clr.w    (a4)
         move.w   eb_dmg(a4),d5
         bsr      Player_Damage
         bra.s    ebd_no_bullet_here
ebd_no_collision:
                                             ; Move enemy bullets
         move.w   eBullet_Code_Table(pc,d6.w),d6     
         jsr      eBullet_Code_Table(pc,d6.w)

ebd_no_bullet_here:
         lea      b_size(a4),a4
         dbra     d7,loop_draw_enemy_bullets
         rts

******************************************** ENEMY BULLET SUBROUTINES

eBullet_Code_Table:
         dc.w     ebx_kill-eBullet_Code_Table
         dc.w     ebx_normal_bullet-eBullet_Code_Table
         dc.w     ebx_aimed_bullet-eBullet_Code_Table
         dc.w     ebx_arrow-eBullet_Code_Table
         dc.w     ebx_guided_right-eBullet_Code_Table
         dc.w     ebx_guided_left-eBullet_Code_Table

ebx_arrow:
         move.w   eb_y(a4),d4
         addq.w   #2,d4
         cmp.w    #140,d4
         bge.s    ebx_kill
         move.w   d4,eb_y(a4)
         rts

ebx_radar_locked:
         cmp.w    #1,player_ship(a5)
         beq.s    ebx_no_radar
ebx_guided_godown:
         move.w   #2,(a4)
         move.w   #in_Guided_Down,e_image(a4)
ebx_normal_bullet:
         move.w   eb_y(a4),d4
         addq.w   #1,d4
         cmp.w    #140,d4
         beq.s    ebx_kill
         move.w   d4,eb_y(a4)
ebx_no_radar:
         rts

ebx_guided_left:
         addq.w   #1,eb_y(a4)
         cmp.w    #140,eb_y(a4)
         beq.s    ebx_kill
         subq.w   #1,eb_x(a4)
         cmp.w    #20,eb_x(a4)
         beq.s    ebx_guided_godown
         move.w   eb_x(a4),d0
         subq.w   #6,d0
         cmp.w    player_xc(a5),d0
         blt.s    ebx_radar_locked
         rts

ebx_guided_right:
         addq.w   #1,eb_y(a4)
         cmp.w    #140,eb_y(a4)
         beq.s    ebx_kill
         addq.w   #1,eb_x(a4)
         cmp.w    #215,eb_x(a4)
         beq.s    ebx_guided_godown
         move.w   eb_x(a4),d0
         subq.w   #6,d0
         cmp.w    player_xc(a5),d0
         bgt.s    ebx_radar_locked
         rts  
ebx_kill:
         clr.w    (a4)
         rts

ebx_aimed_bullet:
         move.w   eb_data(a4),d0
         bge.s    eab_ok_positive_1
         neg.w    d0
eab_ok_positive_1:
         move.w   edir_table(pc,d0.w),d2
         move.w   edir_table+2(pc,d0.w),d1

         move.w   cycle_counter+2(a5),d0
         and.w    #3,d0
         add.w    d1,d0
         lsr.w    #2,d0

         tst.w    eb_data(a4)
         bge.s    eab_ok_positive_2
         neg.w    d0
eab_ok_positive_2:

         add.w    eb_x(a4),d0
         move.w   d0,eb_x(a4)
         ble.s    ebx_kill
         cmp.w    #222,d0
         bgt.s    ebx_kill

         move.w   cycle_counter+2(a5),d0
         and.w    #3,d0
         add.w    d2,d0
         lsr.w    #2,d0
         add.w    eb_y(a4),d0
         move.w   d0,eb_y(a4)
         cmp.w    #140,d0
         bgt.s    ebx_kill
         rts

edir_table:
         dc.w     6,0
         dc.w     5,1,4,2,4,3,3,4,3,4,2,4,2,4,2,4,2,5,1,5,1,5,1,5
