****************************************************************************
****************************************************************************
**                                                                        **
**   Phoenix for TI-89, TI-92, and TI-92 Plus: Shop Routines              **
**                                                                        **
**   Copyright 1997-2000 by Patrick Davidson.  All Rights Reserved.       **
**                                                                        **
**   This file was last updated April 19, 2000                            **
**                                                                        **
**   For complete copyright information and contact addresses, refer to   **
**   the main source file "PHOENIX.ASM"                                   **
**                                                                        **
****************************************************************************
****************************************************************************

      IFD ti89d
K_CHEAT  set      120
SPACING  set      180
L_SHIELD set      99
      ENDIF

      IFND ti89d
K_CHEAT  set      262
SPACING  set      240
L_SHIELD set      121
      ENDIF

******************************************** PURCHASE ITEMS

Phoenix_Shop:
         cmp.w    #50,cash(a5)
         bmi      Status_Prepare

         bsr      Clear_Screen
      IFD ti89d
         moveq    #0,d0
      ENDIF
      IFND ti89d
         moveq    #1,d0
      ENDIF
         bsr      Set_Font

         moveq    #0,d0                      ; Enable interrupts
         trap     #1

         moveq    #num_i-1,d7                ; number of items remaining
         moveq    #16,d6                     ; Y-coordinate
         lea      Phoenix_Shop_Items(pc),a4  ; A4 -> item table
         lea      (a4),a3                    ; A3 -> item table
PSI_ITEMS:
         moveq    #12,d1                     ; X-coordinate for this line
         move.l   d6,d0                      ; Y-coordinate for this line
         move.l   (a4)+,d4                   ; Load data about this item
                                             ; and advance A4 to point to
                                             ; next item.
         lea      0(a3,d4.w),a0              ; Get ptr to info string in A0
      IFND ti89d
         addq.l   #8,d6                      ; Calc next Y-coordinate
      ENDIF
      IFD ti89d
         addq.l   #6,d6
      ENDIF
         bsr      Display_String             ; Display item info
         dbra     d7,PSI_ITEMS               ; Next item or finish

         moveq    #0,D5                      ; D5 = item selected
Phoenix_Shop_Loop:
         cmp.w    #50,cash(a5)
         bmi      Status_Prepare

         lea      LCD_MEM+30,a0              ; Clear game play area
         moveq    #7,d1
         moveq    #0,d0
PSL_CLS: move.l   d0,(a0)+
         move.l   d0,(a0)+
         move.l   d0,(a0)+
         move.l   d0,(a0)+
         move.l   d0,(a0)+
         move.l   d0,(a0)+
         move.w   d0,(a0)+
         move.b   d0,(a0)+
         addq.l   #3,a0
         dbra     d1,PSL_CLS

         moveq    #111,d1
PSL_CLC: move.b   d0,(a0)
         lea      30(a0),a0
         dbra     d1,PSL_CLC

      IFND ti89d
         pea      _shop_title(pc)            ; Display shop title
         jsr      tios::ST_showHelp
      ENDIF
      IFD ti89d
         moveq    #1,d0                      ; Set font to normal
         bsr      Set_Font
      ENDIF

         lea      _string_buffer(a5),a4      ; A4 -> string buffer
         move.w   cash(a5),-(sp)             ; Push amount of cash
         pea      _shop_info(pc)             ; Push format string
         pea      (a4)                       ; Push buffer address
         jsr      tios::sprintf              ; Write string into buffer
         lea      (a4),a0
         moveq    #1,d0
         moveq    #0,d1
         bsr      Display_String             ; Print Title message
      IFND ti89d
         lea      14(sp),sp
      ENDIF
      IFD ti89d
         lea      10(sp),sp
      ENDIF

         move.w   d5,d4
         mulu     #SPACING,d4
      IFND ti89d
         lea      LCD_MEM+480,a0
      ENDIF
      IFD ti89d
         lea      LCD_MEM+420,a0
      ENDIF
         add.w    d4,a0
         lea      arrow(pc),a1
         moveq    #7,d0
loop_draw_arrow:
         move.b   (a1)+,(a0)
         lea      30(a0),a0
         dbra     d0,loop_draw_arrow

         bsr      Get_Key                    ; Wait for keypress
         cmp.w    #K_CHEAT,d0
         bne.s    no_cheating
         swap     d5
         move.w   #-1000,d5
         bsr      Player_Damage
         swap     d5
         st       cheated(a5)
no_cheating:

         cmp.w    #264,d0                    ; Test ESC key
         beq      Status_Prepare

      IFND ti89
         cmp.w    #338,d0                    ; Test up arrow
         beq.s    shop_go_up
         cmp.w    #342,d0
         beq.s    shop_go_up
         cmp.w    #339,d0
         beq.s    shop_go_up
         cmp.w    #348,d0                    ; Test down arrow
         beq.s    shop_go_down
         cmp.w    #344,d0
         beq.s    shop_go_down
         cmp.w    #345,d0
         beq.s    shop_go_down
      ENDIF

      IFD ti89
         cmp.w    #337,d0                    ; Test up arrow
         beq.s    shop_go_up
         cmp.w    #340,d0                    ; Test down arrow
         beq.s    shop_go_down
      ENDIF

         cmp.w    #13,d0
         bne      Phoenix_Shop_Loop

         move.w   d5,d4                      
         add.w    d4,d4
         add.w    d4,d4                      ; D4 = offset of table entry
         move.w   Phoenix_Shop_Items(pc,d4.w),d0
         lea      Phoenix_Shop_Items(pc,d0.w),a0
         move.w   cash(a5),d0                ; D0 = current cash
         sub.w    (a0),d0                    ; D0 = cash left
         bmi      Phoenix_Shop_Loop          ; Cancel purchase if <0
         move.w   d0,cash(a5)                ; Save new amount of money
         jsr      2(a0)                      ; Call activation routine
         bra      Phoenix_Shop_Loop

shop_go_up:
         tst.w    d5
         beq      Phoenix_Shop_Loop
         subq.w   #1,d5
         bra      Phoenix_Shop_Loop

shop_go_down:
         cmp.w    #num_i-1,d5
         beq      Phoenix_Shop_Loop
         addq.w   #1,d5
         bra      Phoenix_Shop_Loop

******************************************** SHOP ITEMS LIST

num_i    set      0

ITEM     MACRO
         dc.w     psd_\1-Phoenix_Shop_Items
         dc.w     psn_\1-Phoenix_Shop_Items
num_i    set      num_i+1
         ENDM

Phoenix_Shop_Items:
         ITEM     Exit_Shop
         ITEM     Shield_Boost
         ITEM     Extra_Bullet
         ITEM     Double_Shoot
         ITEM     Triple_Shoot
         ITEM     Quadruple_Shoot
         ITEM     Rapid_Fire
         ITEM     Dual_Plasma_Cannon
         ITEM     Ship_2
         ITEM     Golden_Arches
         ITEM     Ship_3
         ITEM     Triple_Plasma_Cannon
         ITEM     Ultimate_Weapon

******************************************** SHOP ITEMS DATA AND CODE        

psd_Shield_Boost:
         dc.w     50
         move.w   player_dmg(a5),d0
         cmp.w    #31,d0
         beq.s    shield_full_already
         addq.w   #1,player_dmg(a5)
         bra      Shield_Update
shield_full_already:
         add.w    #50,cash(a5)
         rts

psd_Extra_Bullet:
         dc.w     100
         move.w   num_b(a5),d0
         cmp.w    #23,d0
         beq.s    bullets_full_already
         addq.w   #1,num_b(a5)
bullets_full_already:
         rts

psd_Double_Shoot:
         dc.w     250
         bset     #1,weapons_available(a5)
         rts

psd_Triple_Shoot:
         dc.w     400
         bset     #2,weapons_available(a5)
         rts

psd_Quadruple_Shoot:
         dc.w     500
         bset     #3,weapons_available(a5)
         rts

psd_Rapid_Fire:
         dc.w     1000
         move.w   #-3,fire_delay(a5)
         rts

psd_Dual_Plasma_Cannon:
         dc.w     1250
         bset     #4,weapons_available(a5)
         rts

psd_Ship_2:
         dc.w     1500
         move.w   #1,player_ship(a5)
         bra      New_Ship

psd_Golden_Arches:
         dc.w     1750
         bset     #5,weapons_available(a5)
         rts

psd_Ship_3:
         dc.w     2000
         move.w   #2,player_ship(a5)
         bra      New_Ship

psd_Triple_Plasma_Cannon:
         dc.w     2500
         bset     #6,weapons_available(a5)
         rts

psd_Ultimate_Weapon:
         dc.w     3000
         bset     #7,weapons_available(a5)
         rts

******************************************** EXIT THE SHOP

psd_Exit_Shop:
         dc.w     0
         addq.l   #4,sp
         bra      Status_Prepare

******************************************** SHOP MESSAGES

_shop_title:
         dc.b     'These prices are a big fat ripoff, but'
         dc.b     'what the heck are you gonna do about it?',0
_shop_info:
      IFND ti89d
         dc.b     'SHOP - MONEY : $%d',0
      ENDIF
      IFD ti89d
         dc.b     'SHOP - YOU HAVE: $%d',0  
      ENDIF

psn_Exit_Shop:
         dc.b     'EXIT THE SHOP...',0
psn_Shield_Boost:
         dc.b     '1 POINT EXTRA HEALTH                     $50',0
psn_Extra_Bullet:
         dc.b     'MORE BULLET CAPACITY                   $100',0
psn_Double_Shoot:
         dc.b     'DOUBLE GUNS [2]                             $250',0
psn_Triple_Shoot:
         dc.b     'TRIPLE GUNS [3]                              $400',0
psn_Quadruple_Shoot:
         dc.b     'QUADRUPLE GUNS [4]                       $500',0
psn_Rapid_Fire:
         dc.b     'RAPID FIRE UNIT                                $1000',0
psn_Dual_Plasma_Cannon:
         dc.b     'DOUBLE CANNON [5]                         $1250',0
psn_Ship_2:
         dc.b     'THE COBRA SHIP                                 $1500',0
psn_Golden_Arches:
         dc.b     'ARCHING CANNONS [6]                      $1750',0
psn_Ship_3:
         dc.b     'THE QUEST SHIP                                 $2000',0
psn_Triple_Plasma_Cannon
         dc.b     'TRIPLE CANNON [7]                           $2500',0
psn_Ultimate_Weapon:
         dc.b     'INSANE TERMINATOR LASER [8]        $3000',0

********************************************* 

arrow:   dc.b     %00011000
         dc.b     %00111100
         dc.b     %01111110
         dc.b     %11111111
         dc.b     %01111110
         dc.b     %00111100
         dc.b     %00011000
         dc.b     %00000000
